deActivatePackage("circlecmd");
package circlecmd
{
	function NMH_Type::send( %this )
	{
		%value = %this.getValue();
		%length = strLen( $MessagePrefix );
		if(strlwr(getWord(%value, 0)) $= "gencircle")
		{
			genCircle(getWord(%value, 1));
			%this.setValue( "" );
		}
		else if(strlwr(getWord(%value, 0)) $= "gencirclein")
		{
			genCircleIn(getWord(%value, 1));
			%this.setValue( "" );
		}
		else if(strlwr(getWord(%value, 0)) $= "gencircleout")
		{
			genCircleOut(getWord(%value, 1));
			%this.setValue( "" );
		}
			parent::send( %this );
	}
};
activatePackage("circlecmd");

function between(%num, %min, %max)
{
	if(%num >= %min & %num <= %max)
	{
		return 1;
	}
	else
	{
		return 0;
	}
}

function genCircle(%sizeb, %xx, %yy, %curx, %cury, %brickpos)
{
	%oldbrickpos = %brickpos;
	if(%xx $= "")
	{
		%xx = 0.5;
		%yy = 0.5;
	}
	if(%sizeb > 0)
	{
		%size = %sizeb-1;
		if(%brickpos $= "")
		{
			%brickpos = "0 0 0";
		}
		if(%curx $= "")
		{
			%curx = 0;
			%cury = 0;
		}
		if(%curx > %size)
		{
			%cury++;
			%curx = 0;
		}
		%dist = VectorDist(%size/2 SPC %size/2 SPC 0, %curx SPC %cury SPC 0);
		if(between(%dist, %size/2-%xx, %size/2+%yy))
		{
			%change = vectorSub(%brickpos, %curx SPC %cury SPC 0);
			%brickpos = %curx SPC %cury SPC 0;
			commandToServer('supershiftbrick', -getWord(%change, 0), getWord(%change, 1), 0);
			plantBrick(1);
			plantBrick(0);
		}
		if(%cury <= %size)
		{
				schedule(5, 0, genCircle, %sizeb, %xx, %yy, %curx+1, %cury, %brickpos);
		}
		else
		{
			commandToServer('superShiftBrick', -getWord(%brickpos, 0), getWord(%brickpos, 1), 0);
		}
	}
}

function genCircleOut(%size)
{
	genCircle(%size, 0.5, 10000000);
}

function genCircleIn(%size)
{
	genCircle(%size, 10000000, 0.5);
}